﻿using Infragistics.Win;
using Infragistics.Win.UltraWinDataSource;
using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApp36
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.ultraDropDown1.SetDataBinding(this.ultraDataSource2, this.ultraDataSource2.Band.Key);
            this.ultraDropDown1.ValueMember = "ID";
            this.ultraDropDown1.DisplayMember = "Name";

            this.ultraCombo1.SetDataBinding(this.ultraDataSource2, this.ultraDataSource2.Band.Key);
            this.ultraCombo1.ValueMember = "ID";
            this.ultraCombo1.DisplayMember = "Name";

            foreach (UltraDataRow dataRow in this.ultraDataSource2.Rows)
            {
                int id = (int)dataRow["ID"];
                string name = (string)dataRow["Name"];
                this.ultraDataSource1.Rows.Add(new object[] { id, id, id, name });
            }

            this.ultraGrid1.InitializeLayout += UltraGrid1_InitializeLayout;
            this.ultraGrid1.SetDataBinding(this.ultraDataSource1, this.ultraDataSource1.Band.Key);
            this.ultraGrid1.BeforeExitEditMode += UltraGrid1_BeforeExitEditMode;
        }

        private void UltraGrid1_BeforeExitEditMode(object sender, Infragistics.Win.UltraWinGrid.BeforeExitEditModeEventArgs e)
        {
            var grid = (UltraGrid)sender;
            var activeCell = grid.ActiveCell;
            if (false == IsTextValid(activeCell))
            {
                activeCell.EditorResolved.Value = activeCell.Value;
                e.Cancel = true;                
            }
        }

        private static bool IsTextValid(UltraGridCell cell)
        {
            return cell.Text.ToLower() != "x";
        }

        private void UltraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            var layout = e.Layout;
            var band = layout.Bands[0];

            band.Columns["UltraCombo"].ValueList = this.ultraCombo1;
            band.Columns["UltraDropDown"].ValueList = this.ultraDropDown1;
        }
    }
}
